Index: src/main/java/mk/ukim/finki/busngo/service/impl/KontrolaServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/KontrolaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/KontrolaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,55 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.Instancanalinija;
+import mk.ukim.finki.busngo.model.entities.Kondukter;
+import mk.ukim.finki.busngo.model.entities.Kontroli;
+import mk.ukim.finki.busngo.repository.KontrolaRepository;
+import mk.ukim.finki.busngo.service.InstancaNaLinijaService;
+import mk.ukim.finki.busngo.service.KondukterService;
+import mk.ukim.finki.busngo.service.KontrolaService;
+import org.springframework.stereotype.Service;
+
+import java.sql.Timestamp;
+import java.time.LocalDateTime;
+import java.util.List;
+
+@Service
+public class KontrolaServiceImpl implements KontrolaService {
+    private final KontrolaRepository kontrolaRepository;
+    private final KondukterService kondukterService;
+    private final InstancaNaLinijaService instancaNaLinijaService;
+
+    public KontrolaServiceImpl(KontrolaRepository kontrolaRepository, KondukterService kondukterService, InstancaNaLinijaService instancaNaLinijaService) {
+        this.kontrolaRepository = kontrolaRepository;
+        this.kondukterService = kondukterService;
+        this.instancaNaLinijaService = instancaNaLinijaService;
+    }
+
+    @Override
+    public List<Kontroli> findAll() {
+        return kontrolaRepository.findAll();
+    }
+
+    @Override
+    public Kontroli create(Long inlId, String email) {
+        Kondukter kondukter = kondukterService.findByEmail(email);
+        Instancanalinija instancanalinija = instancaNaLinijaService.findById(inlId);
+        Kontroli kontroli = new Kontroli();
+        kontroli.setKontrolaDatum(Timestamp.valueOf(LocalDateTime.now()));
+        kontroli.setKorisnikByKondukterKId(kondukter);
+        kontroli.setInstancanalinijaByInlId(instancanalinija);
+
+        return kontrolaRepository.save(kontroli);
+    }
+
+    @Override
+    public Kontroli findById(Long kontrolaId) {
+        return kontrolaRepository.findById(kontrolaId).orElseThrow(RuntimeException::new);
+    }
+
+    @Override
+    public List<Kontroli> findAllByInl(Long inlId) {
+        Instancanalinija instancanalinija = instancaNaLinijaService.findById(inlId);
+        return kontrolaRepository.findAllByInstancanalinijaByInlId(instancanalinija);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/LinijaServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/LinijaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/LinijaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,29 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.Linija;
+import mk.ukim.finki.busngo.model.exceptions.InvalidLinijaIdException;
+import mk.ukim.finki.busngo.repository.LinijaRepository;
+import mk.ukim.finki.busngo.service.LinijaService;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+
+@Service
+public class LinijaServiceImpl implements LinijaService {
+
+    private final LinijaRepository linijaRepository;
+
+    public LinijaServiceImpl(LinijaRepository linijaRepository) {
+        this.linijaRepository = linijaRepository;
+    }
+
+    @Override
+    public List<Linija> findAll() {
+        return linijaRepository.findAll();
+    }
+
+    @Override
+    public Linija findById(Long liId) {
+        return linijaRepository.findById(liId).orElseThrow(InvalidLinijaIdException::new);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/PatnikServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/PatnikServiceImpl.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/PatnikServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -1,10 +1,14 @@
 package mk.ukim.finki.busngo.service.impl;
 
+import mk.ukim.finki.busngo.model.entities.Instancanalinija;
+import mk.ukim.finki.busngo.model.entities.Korisnik;
 import mk.ukim.finki.busngo.model.entities.Patnik;
 import mk.ukim.finki.busngo.model.exceptions.InvalidPatnikIdException;
 import mk.ukim.finki.busngo.repository.PatnikRepository;
+import mk.ukim.finki.busngo.service.InstancaNaLinijaService;
 import mk.ukim.finki.busngo.service.PatnikService;
 import org.springframework.stereotype.Service;
 
+import java.util.Collections;
 import java.util.List;
 
@@ -12,12 +16,14 @@
 public class PatnikServiceImpl implements PatnikService {
     private final PatnikRepository patnikRepository;
+    private final InstancaNaLinijaService instancaNaLinijaService;
 
-    public PatnikServiceImpl(PatnikRepository patnikRepository) {
+    public PatnikServiceImpl(PatnikRepository patnikRepository, InstancaNaLinijaService instancaNaLinijaService) {
         this.patnikRepository = patnikRepository;
+        this.instancaNaLinijaService = instancaNaLinijaService;
     }
 
     @Override
     public List<Patnik> listAll() {
-        return patnikRepository.findAll();
+        return  patnikRepository.findAll();
     }
 
@@ -26,3 +32,24 @@
         return patnikRepository.findById(id).orElseThrow(InvalidPatnikIdException::new);
     }
+
+    @Override
+    public Patnik loadUserByEmail(String email) {
+        return patnikRepository.findByKEmail(email).orElseThrow(InvalidPatnikIdException::new);
+    }
+
+    @Override
+    public Patnik save(Korisnik korisnik) {
+        Patnik patnik = new Patnik();
+        patnik.setKId(korisnik.getKId());
+        patnik.setKEmail(korisnik.getKEmail());
+        patnik.setKAdresa(korisnik.getKAdresa());
+        patnik.setKIme(korisnik.getKIme());
+        patnik.setKTelefon(korisnik.getKTelefon());
+        patnik.setKIsAdmin(korisnik.getKIsAdmin());
+        patnik.setKLozinka(korisnik.getKLozinka());
+
+        return patnikRepository.save((Patnik) korisnik);
+    }
+
+
 }
Index: src/main/java/mk/ukim/finki/busngo/service/impl/PostojkaNaLinijaServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/PostojkaNaLinijaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/PostojkaNaLinijaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,44 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.Linija;
+import mk.ukim.finki.busngo.model.entities.Postojkanalinija;
+import mk.ukim.finki.busngo.model.exceptions.InvalidPostojkaNaLinijaIdException;
+import mk.ukim.finki.busngo.repository.PostojkaNaLinijaRepository;
+import mk.ukim.finki.busngo.service.LinijaService;
+import mk.ukim.finki.busngo.service.PostojkaNaLinijaService;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+
+@Service
+public class PostojkaNaLinijaServiceImpl implements PostojkaNaLinijaService {
+    private final PostojkaNaLinijaRepository postojkaNaLinijaRepository;
+    private final LinijaService linijaService;
+
+    public PostojkaNaLinijaServiceImpl(PostojkaNaLinijaRepository postojkaNaLinijaRepository, LinijaService linijaService) {
+        this.postojkaNaLinijaRepository = postojkaNaLinijaRepository;
+        this.linijaService = linijaService;
+    }
+
+    @Override
+    public List<Postojkanalinija> findAll() {
+        return postojkaNaLinijaRepository.findAll();
+    }
+
+    @Override
+    public Postojkanalinija findById(Long id) {
+        return postojkaNaLinijaRepository.findById(id).orElseThrow(InvalidPostojkaNaLinijaIdException::new);
+    }
+
+    @Override
+    public List<Postojkanalinija> findByLinija(Long liId) {
+        Linija linija = linijaService.findById(liId);
+        return postojkaNaLinijaRepository.findAllByLinijaByLiId(linija);
+    }
+
+    @Override
+    public List<Postojkanalinija> findByLinijaAfterRedenBroj(Long liId, Short redenBroj) {
+        Linija linija = linijaService.findById(liId);
+        return postojkaNaLinijaRepository.findAllByLinijaByLiIdAndPnlRedenBrojGreaterThan(linija, redenBroj);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/VozacServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/VozacServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/VozacServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,28 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.Vozac;
+import mk.ukim.finki.busngo.model.exceptions.InvalidVozacIdException;
+import mk.ukim.finki.busngo.repository.VozacRepository;
+import mk.ukim.finki.busngo.service.VozacService;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+
+@Service
+public class VozacServiceImpl implements VozacService {
+    private final VozacRepository vozacRepository;
+
+    public VozacServiceImpl(VozacRepository vozacRepository) {
+        this.vozacRepository = vozacRepository;
+    }
+
+    @Override
+    public List<Vozac> findAll() {
+        return vozacRepository.findAll();
+    }
+
+    @Override
+    public Vozac findByEmail(String email) {
+        return vozacRepository.findByKEmail(email).orElseThrow(InvalidVozacIdException::new);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/VozenjeServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/VozenjeServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/VozenjeServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,75 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.*;
+import mk.ukim.finki.busngo.model.enums.BILET_STATUS;
+import mk.ukim.finki.busngo.model.enums.VOZENJE_STATUS;
+import mk.ukim.finki.busngo.model.exceptions.InvalidVozenjeIdException;
+import mk.ukim.finki.busngo.repository.VozenjeRepository;
+import mk.ukim.finki.busngo.service.*;
+import org.springframework.stereotype.Service;
+
+import java.sql.Timestamp;
+import java.time.LocalDateTime;
+import java.util.List;
+
+@Service
+public class VozenjeServiceImpl  implements VozenjeService {
+    private final VozenjeRepository vozenjeRepository;
+    private final PatnikService patnikService;
+    private final BiletService biletService;
+    private final PostojkaNaLinijaService postojkaNaLinijaService;
+    private final InstancaNaLinijaService instancaNaLinijaService;
+
+    public VozenjeServiceImpl(VozenjeRepository vozenjeRepository, PatnikService patnikService, BiletService biletService, PostojkaNaLinijaService postojkaNaLinijaService, InstancaNaLinijaService instancaNaLinijaService) {
+        this.vozenjeRepository = vozenjeRepository;
+        this.patnikService = patnikService;
+        this.biletService = biletService;
+        this.postojkaNaLinijaService = postojkaNaLinijaService;
+        this.instancaNaLinijaService = instancaNaLinijaService;
+    }
+
+    @Override
+    public List<Vozenje> findVozenjaByPatnik(String email) {
+        Patnik patnik = patnikService.loadUserByEmail(email);
+        return vozenjeRepository.findAllByKorisnikByPatnikKId(patnik);
+    }
+
+    @Override
+    public Vozenje start(String email, Long bId, Long pnlId, Long inlId) {
+        Patnik patnik = patnikService.loadUserByEmail(email);
+        Bilet bilet = biletService.findBybIdAndPatnikEmail(bId, email);
+        Postojkanalinija postojkanalinija = postojkaNaLinijaService.findById(pnlId);
+        Instancanalinija instancanalinija = instancaNaLinijaService.findById(inlId);
+
+        Vozenje vozenje = new Vozenje();
+        vozenje.setVozenjeStart(Timestamp.valueOf(LocalDateTime.now()));
+        vozenje.setVozenjeStatus(VOZENJE_STATUS.ACTIVE);
+        vozenje.setInstancanalinijaByInlId(instancanalinija);
+        vozenje.setKorisnikByPatnikKId(patnik);
+        vozenje.setPostojkanalinijaByKacuvaPnlId(postojkanalinija);
+
+        if(bilet.getBStatus().equals(BILET_STATUS.INACTIVE))
+            bilet = biletService.activate(bId);
+        else if(biletService.checkExpiration(bId))
+            throw new RuntimeException("Bilet is expired!");
+        else if(bilet.getBStatus().equals(BILET_STATUS.EXPIRED))
+            throw new RuntimeException("Bilet is expired!");
+
+        vozenje.setBiletByBId(bilet);
+        return vozenjeRepository.save(vozenje);
+    }
+
+    @Override
+    public Vozenje end(Long vozenjeId, Long pnlId) {
+        // TODO : Relacija se simnuva na pnlId
+        Vozenje vozenje = this.findById(vozenjeId);
+        vozenje.setVozenjeEnd(Timestamp.valueOf(LocalDateTime.now()));
+        vozenje.setVozenjeStatus(VOZENJE_STATUS.FINISHED);
+        return vozenjeRepository.save(vozenje);
+    }
+
+    @Override
+    public Vozenje findById(Long id) {
+        return vozenjeRepository.findById(id).orElseThrow(InvalidVozenjeIdException::new);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/web/BiletController.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/web/BiletController.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/web/BiletController.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -1,7 +1,10 @@
 package mk.ukim.finki.busngo.web;
 
+import mk.ukim.finki.busngo.model.entities.Patnik;
 import mk.ukim.finki.busngo.model.enums.BILET_STATUS;
+import mk.ukim.finki.busngo.model.exceptions.InvalidPatnikIdException;
 import mk.ukim.finki.busngo.service.AuthService;
 import mk.ukim.finki.busngo.service.BiletService;
+import mk.ukim.finki.busngo.service.PatnikService;
 import mk.ukim.finki.busngo.service.TipBiletService;
 import org.springframework.security.core.Authentication;
@@ -21,9 +24,11 @@
     private final TipBiletService tipBiletService;
     private final AuthService authService;
+    private final PatnikService patnikService;
 
-    public BiletController(BiletService biletService, TipBiletService tipBiletService, AuthService authService) {
+    public BiletController(BiletService biletService, TipBiletService tipBiletService, AuthService authService, PatnikService patnikService) {
         this.biletService = biletService;
         this.tipBiletService = tipBiletService;
         this.authService = authService;
+        this.patnikService = patnikService;
     }
 
@@ -31,7 +36,18 @@
     public String getAllBileti(@RequestParam(required = false) Long id,
                                @RequestParam(required = false) BILET_STATUS status,
-                               Model model){
+                               Model model,
+                               Authentication authentication){
         model.addAttribute("bodyContent", "listBileti");
-        model.addAttribute("bileti", biletService.listAll());
+        Patnik patnik = null;
+        try{
+            model.addAttribute("bileti", biletService.findAllByPatnikEmail(authentication.getName()));
+        }
+        catch (InvalidPatnikIdException e){
+            model.addAttribute("bodyContent", "listBileti");
+            model.addAttribute("hasError", true);
+            model.addAttribute("error", e.getMessage());
+            return "master-template";
+        }
+
         return "master-template";
     }
@@ -50,3 +66,9 @@
     }
 
+//    @GetMapping("/encode")
+//    public String encode(){
+//        biletService.encode();
+//        return "redirect:/bilet";
+//    }
+
 }
Index: src/main/java/mk/ukim/finki/busngo/web/InstancaNaLinijaController.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/web/InstancaNaLinijaController.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/web/InstancaNaLinijaController.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,77 @@
+package mk.ukim.finki.busngo.web;
+
+import mk.ukim.finki.busngo.model.entities.Avtobus;
+import mk.ukim.finki.busngo.model.entities.Instancanalinija;
+import mk.ukim.finki.busngo.model.entities.Linija;
+import mk.ukim.finki.busngo.service.AvtobusService;
+import mk.ukim.finki.busngo.service.InstancaNaLinijaService;
+import mk.ukim.finki.busngo.service.KontrolaService;
+import mk.ukim.finki.busngo.service.LinijaService;
+import org.springframework.security.core.Authentication;
+import org.springframework.stereotype.Controller;
+import org.springframework.ui.Model;
+import org.springframework.web.bind.annotation.*;
+
+import java.util.List;
+
+@Controller
+@RequestMapping("instanca-na-linija")
+public class InstancaNaLinijaController {
+    private final InstancaNaLinijaService instancaNaLinijaService;
+    private final LinijaService linijaService;
+    private final AvtobusService avtobusService;
+    private final KontrolaService kontrolaService;
+
+    public InstancaNaLinijaController(InstancaNaLinijaService instancaNaLinijaService, LinijaService linijaService, AvtobusService avtobusService, KontrolaService kontrolaService) {
+        this.instancaNaLinijaService = instancaNaLinijaService;
+        this.linijaService = linijaService;
+        this.avtobusService = avtobusService;
+        this.kontrolaService = kontrolaService;
+    }
+
+    @GetMapping()
+    public String getList(Model model){
+        model.addAttribute("bodyContent", "listInstanci");
+        model.addAttribute("inls", instancaNaLinijaService.findAllActive());
+
+        return "master-template";
+    }
+    @GetMapping("/start")
+    public String getStartPage(Model model){
+        List<Linija> linijaList = linijaService.findAll();
+        List<Avtobus> avtobusList = avtobusService.findAll();
+        model.addAttribute("avtobusi", avtobusList);
+        model.addAttribute("linii", linijaList);
+        model.addAttribute("bodyContent", "startInstanca");
+
+        return "master-template";
+    }
+
+    @PostMapping("/start")
+    public String startInstanca(@RequestParam String aRegistracija,
+                                @RequestParam Long liId,
+                                Model model,
+                                Authentication authentication){
+        Instancanalinija start = instancaNaLinijaService.start(liId, aRegistracija, authentication.getName());
+//        model.addAttribute("inl", start);
+//        model.addAttribute("bodyContent", "inlShow");
+
+        return "redirect:/instanca-na-linija/" + start.getInlId();
+    }
+
+    @GetMapping("/{inlId}")
+    public String getInlShow(@PathVariable Long inlId,
+                             Model model){
+        model.addAttribute("inl", instancaNaLinijaService.findById(inlId));
+        model.addAttribute("kontroli", kontrolaService.findAllByInl(inlId));
+        model.addAttribute("bodyContent", "inlShow");
+
+        return "master-template";
+    }
+
+    @PostMapping("/{inlId}/end")
+    public String endInstanca(@PathVariable Long inlId){
+        Instancanalinija ended = instancaNaLinijaService.end(inlId);
+        return "redirect:/instanca-na-linija/" + ended.getInlId();
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/web/KaznaController.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/web/KaznaController.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/web/KaznaController.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,39 @@
+package mk.ukim.finki.busngo.web;
+
+import mk.ukim.finki.busngo.model.entities.Patnik;
+import mk.ukim.finki.busngo.model.exceptions.InvalidPatnikIdException;
+import mk.ukim.finki.busngo.service.KaznaZaRegistriranService;
+import mk.ukim.finki.busngo.service.VozenjeService;
+import org.springframework.security.core.Authentication;
+import org.springframework.stereotype.Controller;
+import org.springframework.ui.Model;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.RequestMapping;
+
+@Controller
+@RequestMapping("/kazna")
+public class KaznaController {
+    private final KaznaZaRegistriranService kaznaZaRegistriranService;
+
+    public KaznaController(KaznaZaRegistriranService kaznaZaRegistriranService) {
+        this.kaznaZaRegistriranService = kaznaZaRegistriranService;
+    }
+
+    @GetMapping()
+    public String getKaznaPage(Model model,
+                                 Authentication authentication){
+        model.addAttribute("bodyContent", "listKazni");
+        Patnik patnik = null;
+        try{
+            model.addAttribute("kazni", kaznaZaRegistriranService.findAllByPatnik(authentication.getName()));
+        }
+        catch (InvalidPatnikIdException e){
+            model.addAttribute("bodyContent", "listBileti");
+            model.addAttribute("hasError", true);
+            model.addAttribute("error", e.getMessage());
+            return "master-template";
+        }
+
+        return "master-template";
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/web/KontrolaController.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/web/KontrolaController.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/web/KontrolaController.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,85 @@
+package mk.ukim.finki.busngo.web;
+
+import mk.ukim.finki.busngo.model.entities.Kontroli;
+import mk.ukim.finki.busngo.model.exceptions.UserShouldNotBeTicketedException;
+import mk.ukim.finki.busngo.service.*;
+import org.springframework.security.core.Authentication;
+import org.springframework.stereotype.Controller;
+import org.springframework.ui.Model;
+import org.springframework.web.bind.annotation.*;
+
+@Controller
+@RequestMapping("/kontrola")
+public class KontrolaController {
+
+    private final KontrolaService kontrolaService;
+    private final KaznaZaRegistriranService kaznaZaRegistriranService;
+    private final KaznaZaNeregistriranService kaznaZaNeregistriranService;
+    private final KaznaService kaznaService;
+    private final PatnikService patnikService;
+    private final VozacService vozacService;
+    private final InstancaNaLinijaService instancaNaLinijaService;
+
+    public KontrolaController(KontrolaService kontrolaService, KaznaZaRegistriranService kaznaZaRegistriranService, KaznaZaNeregistriranService kaznaZaNeregistriranService, KaznaService kaznaService, PatnikService patnikService, VozacService vozacService, InstancaNaLinijaService instancaNaLinijaService) {
+        this.kontrolaService = kontrolaService;
+        this.kaznaZaRegistriranService = kaznaZaRegistriranService;
+        this.kaznaZaNeregistriranService = kaznaZaNeregistriranService;
+        this.kaznaService = kaznaService;
+        this.patnikService = patnikService;
+        this.vozacService = vozacService;
+        this.instancaNaLinijaService = instancaNaLinijaService;
+    }
+
+    @GetMapping("/{kontrolaId}")
+    public String get(@PathVariable Long kontrolaId,
+                      Model model){
+        model.addAttribute("bodyContent", "kontrola");
+        Kontroli kontroli = kontrolaService.findById(kontrolaId);
+
+        model.addAttribute("kontrola", kontroli);
+        model.addAttribute("kazni", kaznaService.findAllByKontrolaId(kontrolaId));
+        model.addAttribute("patnici", patnikService.listAll());
+        return "master-template";
+    }
+    @GetMapping("/start-for/{inlId}")
+    public String getStartPage(@PathVariable Long inlId,
+                               Model model,
+                               Authentication authentication){
+        model.addAttribute("bodyContent", "kontrola");
+        Kontroli kontroli = kontrolaService.create(inlId, authentication.getName());
+
+        model.addAttribute("kontrola", kontroli);
+        return "redirect:/kontrola/" + kontroli.getKontrolaId();
+    }
+
+    @PostMapping("/{kontrolaId}/kazni-registriran")
+    public String kazniRegistriran(@PathVariable Long kontrolaId,
+                                   @RequestParam String dokument,
+                                   @RequestParam Double iznos,
+                                   @RequestParam Long patnik,
+                                   Authentication authentication){
+        try {
+
+            kaznaZaRegistriranService.create(kontrolaId, dokument, iznos, patnik, authentication.getName());
+        }
+        catch (UserShouldNotBeTicketedException exception){
+            return "redirect:/kontrola/" + kontrolaId;
+        }
+
+        return "redirect:/kontrola/" + kontrolaId;
+    }
+
+    @PostMapping("/{kontrolaId}/kazni-neregistriran")
+    public String kazniNeregistriran(@PathVariable Long kontrolaId,
+                                   @RequestParam String dokument,
+                                   @RequestParam Double iznos,
+                                   @RequestParam String telefon,
+                                   @RequestParam String ime,
+                                   @RequestParam String adresa,
+                                   Authentication authentication){
+
+        kaznaZaNeregistriranService.create(kontrolaId, dokument, iznos, telefon, ime, adresa, authentication.getName());
+
+        return "redirect:/kontrola/" + kontrolaId;
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/web/RegisterController.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/web/RegisterController.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/web/RegisterController.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -1,9 +1,10 @@
 package mk.ukim.finki.busngo.web;
 
-import mk.ukim.finki.busngo.model.enums.Role;
+import mk.ukim.finki.busngo.model.entities.Korisnik;
 import mk.ukim.finki.busngo.model.exceptions.InvalidCredentialsException;
 import mk.ukim.finki.busngo.model.exceptions.UserAlreadyExistsException;
 import mk.ukim.finki.busngo.service.AuthService;
 import mk.ukim.finki.busngo.service.KorisnikService;
+import mk.ukim.finki.busngo.service.PatnikService;
 import org.springframework.stereotype.Controller;
 import org.springframework.ui.Model;
@@ -18,8 +19,10 @@
     private final AuthService authService;
     private final KorisnikService korisnikService;
+    private final PatnikService patnikService;
 
-    public RegisterController(AuthService authService, KorisnikService korisnikService) {
+    public RegisterController(AuthService authService, KorisnikService korisnikService, PatnikService patnikService) {
         this.authService = authService;
         this.korisnikService = korisnikService;
+        this.patnikService = patnikService;
     }
 
@@ -44,5 +47,6 @@
     ) {
         try{
-            this.authService.register(name, email, password, confirmPassword, address, phone);
+            Korisnik korisnik = this.authService.registerPatnik(name, email, password, confirmPassword, address, phone);
+            this.patnikService.save(korisnik);
             return "redirect:/login";
         } catch (InvalidCredentialsException | UserAlreadyExistsException exception) {
@@ -51,3 +55,13 @@
     }
 
+//    @PostMapping
+//    public String registerVraboten(@RequestParam String name,
+//                                   @RequestParam String email,
+//                                   @RequestParam String password,
+//                                   @RequestParam String confirmPassword,
+//                                   @RequestParam String address,
+//                                   @RequestParam String phone){
+//
+//    }
+
 }
